// Filename: DOCOFF.C                                       
// "PROJECT" Generated by WinMaker Pro.                     
// Author:   Geoff Caras                                    

// 
// ***********************************************************************
// Code in this file is initially generated by the Ansi C Switch-It Module.
// This file contains functions you can change
// to provide whatever functionality you require.
// 
// 
// 
// For more information,
// see the section "How code is generated" in the documentation.
// 
// ***********************************************************************
// 
 
#include "WINDOWS.H"
#include "COFFLOAD.H"  

WMPDEBUG
#include "DOCOFF.WMC"

WORD    Debug = 0;

BOOLEAN Verbose;

char   *SectionNameFilter = NULL;

extern  BOOLEAN ProcessHSIError(EC);
extern  BOOLEAN ProcessGameError(WORD);
extern  BOOLEAN SetPC(DWORD);
extern  BOOLEAN IssueGo(void);
extern  BOOLEAN ControlGame(BYTE, BYTE);
extern  BOOLEAN ToAddr(HANDLE fh);
extern  BOOLEAN LoadMonitor(void);


// This is the COFF Loader for Windows functionality code...
BOOLEAN
DownloadCOFF(HWND hWnd, char *filename, BOOLEAN WinVerbose, BOOLEAN InhibitGO, BOOLEAN LoadMon)
{

    HANDLE      hf;     // File handle, Win32 style.

    FILHDR      Hdr;
    AOUTHDR     OptHdr;
    SCNHDR      SecHdr;

    SectionInfoT    *SectionHeadPtr,
                    *SectionPtr;

    int     i,
            NumSections,
            SectionID,
            MemPoolSize;

    BOOLEAN FilterThisSection;

    BYTE   *MemPool;
                
    DWORD   BytesToLoad,
            BytesRead,
            Address,
            FileOffset,
            HeaderOffset,
            lpNumberOfBytesRead;

    EC      stat;

    Verbose = WinVerbose;

    if(LoadMon == TRUE) {
        if(LoadMonitor() == FALSE) {
            // Unable to load monitor...
            MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT(">>> Unable to load monitor."));
            return(FALSE);
        }
    }
        
    // Issue a MakeSafe to put the monitor in a known state.
    stat = MON_MakeSafe(uP_SH2_Main);

    if(ProcessHSIError(stat) == FALSE)
        return(FALSE);

    FilterThisSection = FALSE;

    MemPoolSize = MON_MEMPOOLSIZE;
    MemPool     = (BYTE *) GlobalAlloc(GPTR, MemPoolSize);

    if(MemPool == NULL) {
        MessageBox(hWnd, "Unable to allocate memory pool!", "COFF Download", MB_ICONSTOP);
        return(FALSE);
    }


    hf = CreateFile((LPCTSTR)filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);

    if (INVALID_HANDLE_VALUE == hf) {
        MessageBox(hWnd, "Unable to open COFF file!", "COFF Download", MB_ICONSTOP);
        GlobalFree(GlobalHandle((LPCVOID)MemPool));
        return(FALSE);
    }

    SectionHeadPtr  = 
    SectionPtr      = NULL;


    ReadFile(hf, (LPVOID)&Hdr, (DWORD)FILHSZ, (LPDWORD)&lpNumberOfBytesRead, NULL);

    Hdr.f_magic  = Swap16(Hdr.f_magic);
    Hdr.f_nscns  = Swap16(Hdr.f_nscns);
    Hdr.f_timdat = Swap32(Hdr.f_timdat);
    Hdr.f_symptr = Swap32(Hdr.f_symptr);
    Hdr.f_nsyms  = Swap32(Hdr.f_nsyms);
    Hdr.f_opthdr = Swap16(Hdr.f_opthdr);
    Hdr.f_flags  = Swap16(Hdr.f_flags);

    if(SHBADMAG(Hdr)) {
        MessageBox(hWnd, "This file is not a valid SH2 COFF file!", "COFF Download", MB_ICONSTOP);
        CloseHandle(hf);
        GlobalFree(GlobalHandle((LPCVOID)MemPool));
        return(FALSE);
    }

    if(Hdr.f_opthdr > 0) {
        ReadFile(hf, (LPVOID)&OptHdr, (DWORD)AOUTSZ, (LPDWORD)&lpNumberOfBytesRead, NULL);

        OptHdr.magic      = Swap16(OptHdr.magic);
        OptHdr.vstamp     = Swap16(OptHdr.vstamp);
        OptHdr.tsize      = Swap32(OptHdr.tsize);
        OptHdr.dsize      = Swap32(OptHdr.dsize);
        OptHdr.bsize      = Swap32(OptHdr.bsize);
        OptHdr.entry      = Swap32(OptHdr.entry);
        OptHdr.text_start = Swap32(OptHdr.text_start);
        OptHdr.data_start = Swap32(OptHdr.data_start);
    }


    if(Verbose == TRUE) {
        MEditPrintF(hOutPutEdit, TEXT("Magic Number            : %04X"), Hdr.f_magic);
        MEditPrintF(hOutPutEdit, TEXT("Number of sections      : %d"),   Hdr.f_nscns);
        MEditPrintF(hOutPutEdit, TEXT("Date & time stamp       : %s"),   ctime(&Hdr.f_timdat));
        MEditPrintF(hOutPutEdit, TEXT("Symtab pointer          : %08X"), Hdr.f_symptr);
        MEditPrintF(hOutPutEdit, TEXT("# Symtab entries        : %08X"), Hdr.f_nsyms);
        MEditPrintF(hOutPutEdit, TEXT("Optional hdr size       : %04X"), Hdr.f_opthdr);
        MEditPrintF(hOutPutEdit, TEXT("Flags                   : %04X"), Hdr.f_flags);

        if(Hdr.f_flags & F_RELFLG)
            MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT("                        : F_RELFLG   Does not contain reloc info."));

        if(Hdr.f_flags & F_EXEC)
            MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT("                        : F_EXEC     File is executable."));

        if(Hdr.f_flags & F_LNNO)
            MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT("                        : F_LNNO     File has no line number info."));

        if(Hdr.f_flags & F_LSYMS)
            MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT("                        : F_LSYMS    Local symbols have been stripped."));

        if(Hdr.f_opthdr > 0) {
            MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT("Optional Header:"));
            MEditPrintF(hOutPutEdit, TEXT("Magic Number            : %04X"),      OptHdr.magic);
            MEditPrintF(hOutPutEdit, TEXT("Version stamp           : %04X"),      OptHdr.vstamp);
            MEditPrintF(hOutPutEdit, TEXT("Text size               : %08X (%d)"), OptHdr.tsize, OptHdr.tsize);
            MEditPrintF(hOutPutEdit, TEXT("Initialized data size   : %08X (%d)"), OptHdr.dsize, OptHdr.dsize);
            MEditPrintF(hOutPutEdit, TEXT("Uninitialized data size : %08X (%d)"), OptHdr.bsize, OptHdr.bsize);
            MEditPrintF(hOutPutEdit, TEXT("Entry Point             : %08X"),      OptHdr.entry);
            MEditPrintF(hOutPutEdit, TEXT("Text start              : %08X"),      OptHdr.text_start);
            MEditPrintF(hOutPutEdit, TEXT("Data start              : %08X"),      OptHdr.data_start);
        }
    }

    NumSections = Hdr.f_nscns;

    // Now Seek to the first Section Header.
    FileOffset = SetFilePointer(hf, (LONG)((FILHSZ + Hdr.f_opthdr)), NULL, FILE_BEGIN);

    for(SectionID = 0; SectionID < NumSections; SectionID++) {

        ReadFile(hf, (LPVOID)&SecHdr, (DWORD)SCNHSZ, (LPDWORD)&lpNumberOfBytesRead, NULL); // Read in the section headers.
        BytesRead = lpNumberOfBytesRead;

        if(BytesRead != SCNHSZ) {
            MEditPrintF(hOutPutEdit, TEXT("Didn't read the entire data structure..(%d)"), BytesRead);
        }

        SecHdr.s_paddr     = Swap32(SecHdr.s_paddr);
        SecHdr.s_vaddr     = Swap32(SecHdr.s_vaddr);
        SecHdr.s_size      = Swap32(SecHdr.s_size);
        SecHdr.s_scnptr    = Swap32(SecHdr.s_scnptr);
        SecHdr.s_relptr    = Swap32(SecHdr.s_relptr);
        SecHdr.s_lnnoptr   = Swap32(SecHdr.s_lnnoptr);
        SecHdr.s_nreloc    = Swap16(SecHdr.s_nreloc);
        SecHdr.s_nlnno     = Swap16(SecHdr.s_nlnno);
        SecHdr.s_flags     = Swap32(SecHdr.s_flags);

        if(SectionPtr == NULL) {
            SectionHeadPtr  = (SectionInfoT *) GlobalAlloc(GPTR, sizeof(SectionInfoT));
            //SectionHeadPtr  = (SectionInfoT *)calloc(sizeof(SectionInfoT), 1);
            SectionPtr      = SectionHeadPtr;

        } else {
            SectionPtr->NextSection = (SectionInfoT *) GlobalAlloc(GPTR, sizeof(SectionInfoT));
            //SectionPtr->NextSection = (SectionInfoT *)calloc(sizeof(SectionInfoT), 1);
            SectionPtr = SectionPtr->NextSection;            
        }

        if(SectionPtr == NULL) {
            MessageBox(hWnd, "Could not allocate memory for data structures.\n", "COFF Downloader", MB_ICONSTOP);
            GlobalFree(GlobalHandle((LPCVOID)MemPool));
            return(FALSE);
        }
            

        for(i = 0; i < 8; i++)
            SectionPtr->SectionName[i] = SecHdr.s_name[i];

        SectionPtr->SectionName[8] = '\0';

        SectionPtr->SectionOffset   = SecHdr.s_scnptr;
        SectionPtr->SectionSize     = SecHdr.s_size;
        SectionPtr->SectionAddress  = SecHdr.s_paddr;
        SectionPtr->NextSection     = NULL;


        if(Verbose == TRUE) {
            MEditPrintF(hOutPutEdit, TEXT("Section [%s]"),                        SectionPtr->SectionName);
            MEditPrintF(hOutPutEdit, TEXT("Physical Address        : %08X"),      SecHdr.s_paddr);
            MEditPrintF(hOutPutEdit, TEXT("Virtual Address         : %08X"),      SecHdr.s_vaddr);
            MEditPrintF(hOutPutEdit, TEXT("Section Size            : %08X"),      SecHdr.s_size);
            MEditPrintF(hOutPutEdit, TEXT("Offset to Raw Data      : %08X"),      SecHdr.s_scnptr);
            MEditPrintF(hOutPutEdit, TEXT("Offset to Reloc Info    : %08X"),      SecHdr.s_relptr);
            MEditPrintF(hOutPutEdit, TEXT("Offset line numbers     : %08X"),      SecHdr.s_lnnoptr);
            MEditPrintF(hOutPutEdit, TEXT("Number of reloc entries : %04X (%d)"), SecHdr.s_nreloc, SecHdr.s_nreloc);
            MEditPrintF(hOutPutEdit, TEXT("Number of line # entries: %04X (%d)"), SecHdr.s_nlnno, SecHdr.s_nlnno);
            MEditPrintF(hOutPutEdit, TEXT("Flags                   : %08X"),      SecHdr.s_flags);
        }
    }


    SectionPtr      = SectionHeadPtr;
    HeaderOffset    = sizeof(CmdHeaderT);

    if(SectionNameFilter != NULL) {
        FilterThisSection = TRUE;

        // Set the gating BOOLEAN FilterThisSection to FALSE when this is a
        // section that we will let through to the game...
        if(lstrcmp(SectionNameFilter, SectionPtr->SectionName) == 0)
            FilterThisSection = FALSE;

    }

    while(SectionPtr != NULL) {
        MEditPrintF(hOutPutEdit, TEXT("Section [%8.8s] @%08X is %d bytes."), 
            SectionPtr->SectionName, SectionPtr->SectionAddress, SectionPtr->SectionSize);

        if(FilterThisSection == TRUE) {
            MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("Section FILTERED"));
            SectionPtr = SectionPtr->NextSection;
            continue;
        }


            // Now Seek to the first Section Header.
            SetFilePointer(hf, (LONG)(SectionPtr->SectionOffset), NULL, FILE_BEGIN);

            BytesToLoad = SectionPtr->SectionSize;
            Address     = SectionPtr->SectionAddress;

            while(BytesToLoad > 0)  {
                memset(MemPool, 0, MemPoolSize);

                if(BytesToLoad <= MemPoolSize) {
                    ReadFile(hf, (LPVOID)MemPool, BytesToLoad, (LPDWORD)&lpNumberOfBytesRead, NULL); // Read in the data.
                    BytesRead    = BytesToLoad;
                    BytesToLoad  = 0;
                } else {
                    ReadFile(hf, (LPVOID)MemPool, MemPoolSize, (LPDWORD)&lpNumberOfBytesRead, NULL); // Read in the data.
                    BytesRead    = MemPoolSize;
                    BytesToLoad -= MemPoolSize;
                }

                if(Debug & 0x4)  {
                    MEditPrintF(hOutPutEdit, TEXT("Pseudo NOT Writing %d bytes to %08X"), BytesRead, Address);
                } else {

                    stat = MON_ByteWrite(Address, BytesRead, MemPool);

                    if(ProcessHSIError(stat) == FALSE) {
                        // Free up our memory...
                        SectionPtr = SectionHeadPtr;

                        while(SectionPtr != NULL) {
                            SectionHeadPtr = SectionPtr->NextSection;
                            GlobalFree(GlobalHandle((LPCVOID)SectionPtr));
                            SectionPtr = SectionHeadPtr;
                        }
                        GlobalFree(GlobalHandle((LPCVOID)MemPool));
                        return(FALSE);
                    }
                }

                Address += BytesRead;
            } 

        SectionPtr = SectionPtr->NextSection;
    }


    if(Hdr.f_opthdr > 0) {

        // Set the entry point by assigning the PC.
        if(Verbose == TRUE)
            MEditPrintF(hOutPutEdit, TEXT("Setting PC = %08X"), OptHdr.entry);

        SetPC(OptHdr.entry);

        if(Verbose == TRUE) {
            if(InhibitGO == TRUE)  
                MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("NOT Issuing a monitor GO command."));
            else            
                MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("Issuing a monitor GO command."));
        }

        if(InhibitGO == FALSE)
            IssueGo();

    } else {
        MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("Optional header was not present. PC not set, will not auto-execute."));
    }

    SectionPtr = SectionHeadPtr;

    while(SectionPtr != NULL) {
        SectionHeadPtr = SectionPtr->NextSection;
        GlobalFree(GlobalHandle((LPCVOID)SectionPtr));
        SectionPtr = SectionHeadPtr;
    }


    GlobalFree(GlobalHandle((LPCVOID)MemPool));
    CloseHandle(hf);
    return(TRUE);
}




/*
͸
 Function name  ProcessHSIError()                                Function 
 Author         Geoff Caras -- The Igneous Group                 Ͱ
                                                                            
 Date        23 Apr 94                                                     
 Version     1.00                                                          
                                                                            
Ĵ
 Description:                                                               
     Prints a message associated with GAME errors.                          
                                                                            
 Valid syntax:                                                              
                                                                            
     ProcessGameError(err)                                                  
                                                                            
 Input Parameters:                                                          
     The error code returned by the game.                                   
                                                                            
 Output Parameters:                                                         
     SUCCESS if the error is an ok status. FAIL and a diagnostic printed    
     otherwise.                                                             
                                                                            
 Revision History:                                                          
                                                                            
 23 Apr 94 GBC created.                                                     
                                                                            
;
*/
BOOLEAN
ProcessHSIError(EC status)
{
    char    hsiErr[255];


    if(status != err_NOERROR) {
        lstrcpy(hsiErr, "*** HSI Error: ");
        lstrcat(hsiErr, HSI_GetErrorText(status));

        /* HSI_GetErrorText() converts an error code (EC) to a string.
        */
        MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)hsiErr);

        // If the debug bit is set don't exit on errors!
        if(Debug & 0x8)
            return(TRUE);

        lstrcat(hsiErr, "\n\rDo you want to Continue?");
        if(IDYES !=  MessageBox(hClient, hsiErr, "COFF Downloader - ProcessHSIError()", MB_YESNO | MB_ICONSTOP)) {
            //PostQuitMessage(WM_QUIT);
            return(FALSE);
        }
    }

    return(TRUE);

}


/*
͸
 Function name  ProcessGameError()                               Function 
 Author         Geoff Caras -- The Igneous Group                 Ͱ
                                                                            
 Date        23 Apr 94                                                     
 Version     1.00                                                          
                                                                            
Ĵ
 Description:                                                               
     Prints a message associated with GAME errors.                          
                                                                            
 Valid syntax:                                                              
                                                                            
     ProcessGameError(err)                                                  
                                                                            
 Input Parameters:                                                          
     The error code returned by the game.                                   
                                                                            
 Output Parameters:                                                         
     SUCCESS if the error is an ok status. FAIL and a diagnostic printed    
     otherwise.                                                             
                                                                            
 Revision History:                                                          
                                                                            
 23 Apr 94 GBC created.                                                     
                                                                            
;
*/
BOOLEAN
ProcessGameError(WORD game_error)
{
    if(game_error == 0)
        return(TRUE);

    game_error = Swap16(game_error);

    switch(game_error) {
        case    merr_NoError: 
            return(TRUE);

        case    merr_XferLnMismatch:
            MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("***GAME ERROR: Transfer length mismatch."));
            break;

        case    merr_InvalidProcessor:
            MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("***GAME ERROR: Invalid processor selected."));
            break;

        case    merr_InvalidCommand:
            MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("***GAME ERROR: Invalid monitor command."));
            break;

        case    merr_CPUOffLine:
            MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("***GAME ERROR: CPU is offline."));
            break;

        default:
            MEditPrintF(hOutPutEdit, TEXT("Unknown ERROR returned from GAME: %04X"), game_error);
            break;
   }
   return(FALSE);
}

BOOLEAN
SetPC(DWORD pc)
{
    SH2_RegisterSetT   SH2Regs;

    EC  stat;

    if(Debug & 0x4) {
        MEditPrintF(hOutPutEdit, TEXT("PC NOT set to %08X"), pc);
        return(TRUE);
    }

    stat = MON_ReadRegisters(uP_SH2_Main, &SH2Regs);

    if(ProcessHSIError(stat) == FALSE)
        return(FALSE);

    SH2Regs.PC = pc;

    stat = MON_WriteRegisters(uP_SH2_Main, &SH2Regs);

    if(ProcessHSIError(stat) == FALSE)
        return(FALSE);

    return(TRUE);
}

BOOLEAN
IssueGo(void)
{
    EC  stat;

    if(Debug & 0x4) {
        MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("GO command NOT issued."));
        return(TRUE);
    } 
    
    stat = MON_Go(uP_SH2_Main);
    
    if(ProcessHSIError(stat) == FALSE)
        return(FALSE);

    return(TRUE);
}

BOOLEAN
ControlGame(BYTE a, BYTE b)
{
    EC  retcode;

    if(Verbose == TRUE) {
        MEditPrintF(hOutPutEdit, TEXT("ControlGame(0x%02X, 0x%02X)"), a, b);
    }

    retcode = HSI_ControlGame(a, b, 0);

    if(ProcessHSIError(retcode) == FALSE)
        return(FALSE);
}

BOOLEAN
ToAddr(HANDLE fhMon)
{
    int     size;

    EC      retcode;

    BYTE   *buf;

    DWORD   BytesRead;

    // Figure out how big the file is...
    SetFilePointer(fhMon, (LONG)0, NULL, FILE_BEGIN);
    size = SetFilePointer(fhMon, (LONG)0, NULL, FILE_END);
    SetFilePointer(fhMon, (LONG)0, NULL, FILE_BEGIN);

    buf = (BYTE *) GlobalAlloc(GPTR, size);

    if(buf == NULL) {
        MessageBox(hClient, "Unable to allocate memory.", "ToADDR()", MB_ICONSTOP);
        return(FALSE);
    }

    ReadFile(fhMon, (LPVOID)buf, size, (LPDWORD)&BytesRead, NULL);

    if(size != BytesRead) {
        MessageBox(hClient, "Unable to read monitor file.", "ToADDR()", MB_ICONSTOP);
    }

    if(Verbose == TRUE) {
        MEditPrintF(hOutPutEdit, TEXT("ToAddr @0xB000000 %d bytes..."), size);
    }

    retcode = HSI_WriteAddr(0xb000000, (CartDevAddrSizeT)size, buf, 0);

    GlobalFree(GlobalHandle((LPCVOID)buf));
    
    if(ProcessHSIError(retcode) == FALSE)
        return(FALSE);

    return(TRUE);
}


BOOLEAN
LoadMonitor(void)
{
    HANDLE  fhMon;

    HANDLE  TimerCompletionEvent;
    DWORD   EventStatus;

    fhMon = CreateFile((LPCTSTR)TEXT(MonitorFile), GENERIC_READ, FILE_ATTRIBUTE_READONLY, NULL, OPEN_EXISTING, 0, 0);

    if(INVALID_HANDLE_VALUE == fhMon) {
        if(IDOK != MessageBox(hClient, "Unable to open monitor <SATMON.BIN>", "Load Monitor", MB_OKCANCEL | MB_ICONSTOP)) {
            PostQuitMessage(WM_QUIT);
            return(FALSE);
        }
    }

    ControlGame(0x06,0x31);         // Set buffer config to default #1
    ControlGame(0x06,0x01);         // Reset CartDev control registers
    ControlGame(0x03,0x30);         // Set mon RAM write protect
    ControlGame(0x03,0x10);         // Set mon RAM access to CartDev

    MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("Sending Monitor to target"));

    if(ToAddr(fhMon) == FALSE)
        return(FALSE);

    CloseHandle(fhMon);

    ControlGame(0x03,0x40);         // Clear mon RAM write protect
    ControlGame(0x03,0x20);         // Set mon RAM access to target
    ControlGame(0x07,0x08);         // magic short screen off


    TimerCompletionEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

    // Delay for 3 Seconds.
    EventStatus = WaitForSingleObject(TimerCompletionEvent, 3*1000);
    ResetEvent(TimerCompletionEvent);

    ControlGame(0x00,0x16);         // System Reset A 15 = FULL 16 = ALL but CD

    MEditPrintF(hOutPutEdit, TEXT("%s"), (LPTSTR)TEXT("Waiting for Saturn to initialize..."));

    // Waiting for Saturn to boot....18 Seconds!
    EventStatus = WaitForSingleObject(TimerCompletionEvent, 18*1000);
    ResetEvent(TimerCompletionEvent);

    CloseHandle(TimerCompletionEvent);
    return(TRUE);
}
