// Filename: DOWNLOAD.C                                     
// "PROJECT" Generated by WinMaker Pro.                     
// Author:   Geoff Caras                                    

// 
// ***********************************************************************
// Code in this file is initially generated by the Ansi C Switch-It Module.
// This file contains functions you can change
// to provide whatever functionality you require.
// 
// 
// 
// For more information,
// see the section "How code is generated" in the documentation.
// 
// ***********************************************************************
// 
 
#include "WINDOWS.H"
#include "COFFLOAD.H"  

WMPDEBUG
#include "DOWNLOAD.WMC"
    
#define Edit_SetSel(hwndCtl, ichStart, ichEnd)  ((void)SendMessage((hwndCtl), EM_SETSEL, (ichStart), (ichEnd)))
#define Edit_ReplaceSel(hwndCtl, lpszReplace)   ((void)SendMessage((hwndCtl), EM_REPLACESEL, 0L, (LPARAM)(LPCTSTR)(lpszReplace)))

TCHAR           gszNull[]           = TEXT("");
TCHAR           gszYes[]            = TEXT("Yes");
TCHAR           gszNo[]             = TEXT("No");
HWND            hClient;
   
//--------------------------------------------------------------------------;
//  
//  int MEditPrintF
//  
//  Description:
//      This function is used to print formatted text into a Multiline
//      Edit Control as if it were a standard console display. This is
//      a very easy way to display small amounts of text information
//      that can be scrolled and copied to the clip-board.
//  
//  Arguments:
//      HWND hedit: Handle to a Multiline Edit control.
//  
//      PTSTR pszFormat: Pointer to any valid format for wsprintf. If
//      this argument is NULL, then the Multiline Edit Control is cleared
//      of all text.
//
//
//  Return (int):
//      Returns the number of characters written into the edit control.
//
//  Notes:
//      The pszFormat string can contain combinations of escapes that 
//      modify the default behaviour of this function. Escapes are single
//      character codes placed at the _beginning_ of the format string.
//
//      Current escapes defined are:
//
//      ~   :   Suppresses the default CR/LF added to the end of the 
//              printed line. Since the most common use of this function
//              is to output a whole line of text with a CR/LF, that is
//              the default.
//
//      `   :   Suppresses logging to the debug terminal (regardless of
//              the global debug log options flag).
//
//  
//--------------------------------------------------------------------------;

int MEditPrintF
(
    HWND                    hedit,
    PTSTR                   pszFormat,
    ...
)
{
    static  TCHAR   szCRLF[]              = TEXT("\r\n");

    va_list     va;
    TCHAR       ach[255];
    int         n;
    BOOL        fCRLF;
    //BOOL        fDebugLog;

    //
    //  default the escapes
    //
    fCRLF     = TRUE;
    //fDebugLog = TRUE;


    //
    //  if the pszFormat argument is NULL, then just clear all text in
    //  the edit control..
    //
    if (NULL == pszFormat)
    {
        SetWindowText(hedit, gszNull);

        //AcmAppDebugLog(NULL);

        return (0);
    }

    //
    //  format and display the string in the window... first search for
    //  escapes to modify default behaviour.
    //
    for (;;)
    {
        switch (*pszFormat)
        {
            case '~':
                fCRLF = FALSE;
                pszFormat++;
                continue;

            case '`':
                //fDebugLog = FALSE;
                pszFormat++;
                continue;
        }

        break;
    }

    va_start(va, pszFormat);
#ifdef WIN32
    n = wvsprintf(ach, pszFormat, va);
#else
    n = wvsprintf(ach, pszFormat, (LPSTR)va);
#endif
    va_end(va);

    Edit_SetSel(hedit, (WPARAM)-1, (LPARAM)-1);
    Edit_ReplaceSel(hedit, ach);

    //if (fDebugLog)
    //{
    //    AcmAppDebugLog(ach);
    //}

    if (fCRLF)
    {
        Edit_SetSel(hedit, (WPARAM)-1, (LPARAM)-1);
        Edit_ReplaceSel(hedit, szCRLF);

        //if (fDebugLog)
        //{
        //    AcmAppDebugLog(szCRLF);
        //}
    }

    return (n);
} // MEditPrintF()




HWND                 hOutPutEdit;

 
//  User Defined Code 
BOOL BLD_ClickedDOWNLOADUDCFunc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
    char        szFile[256];   

    int         i;

    BOOLEAN     Verbose,
                InhibitGO,
                LoadMonitor;

    Verbose     =
    InhibitGO   =     
    LoadMonitor = FALSE;

    hClient     = hWnd;


    hOutPutEdit = GetDlgItem(hWnd, ID_EDIT_WINDOW);

    szFile[0] = '\0';

    i = SendDlgItemMessage(hWnd, ID_FILESPEC, WM_GETTEXT, (WPARAM)255, (LPARAM)(LPCTSTR)szFile);

    if((i == 0) || (strlen(szFile) == 0)) {

        MessageBox(hWnd, "You must specify a file to download!", "COFF File Download", MB_ICONSTOP);
        return(FALSE);

    } else if(GetFileAttributes((LPCTSTR)szFile) == -1) {

        char  tmpbuf[255];
        strcpy(tmpbuf, "Invalid filename: <");
        strcat(tmpbuf, szFile);
        strcat(tmpbuf, ">");
        MessageBox(hWnd, tmpbuf, "COFF File Download", MB_ICONSTOP);
        return(FALSE);
    }

    if(IsDlgButtonChecked(hWnd, ID_INHIBIT_GO)) {
        MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT(">>> GO monitor command will not be sent after download."));
        InhibitGO   = TRUE;
    }

    if(IsDlgButtonChecked(hWnd, ID_VERBOSE)) {
        MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT(">>> Verbose ON."));
        Verbose     = TRUE;
    }

    if(IsDlgButtonChecked(hWnd, ID_LOAD_MONITOR)) {
        MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT(">>> Monitor will be loaded first."));
        LoadMonitor = TRUE;
    }

    MEditPrintF(hOutPutEdit, TEXT("Downloading: %s"), (LPTSTR)szFile);

    if(FALSE == DownloadCOFF(hWnd, szFile, Verbose, InhibitGO, LoadMonitor)) {
        MEditPrintF(hOutPutEdit, TEXT("%s"),(LPTSTR)TEXT(">>> Download FAILED! <<<"));
        return(FALSE);
    }

    return TRUE;
}
